<?php

// ajax class

class Mga_Ajax{

	var $is_ajax=false; 

	// constructor

	function Mga_Ajax(){

		// check if ajax

		$this->is_ajax=(isset($_SERVER["HTTP_X_REQUESTED_WITH"]) && $_SERVER["HTTP_X_REQUESTED_WITH"]  == 'XMLHttpRequest')?TRUE:FALSE;

	}	

	// check if ajax

	function Is_Ajax(){

		return $this->is_ajax;

	}	

	// header

	function Send_Header(){

		if(eregi('application/json',$_SERVER['HTTP_ACCEPT'])){

			header("Content-type:application/json");	

		}else if(eregi('text/javascript',$_SERVER['HTTP_ACCEPT'])){

			header("Content-type:text/javascript");	

		}else if(eregi('text/plain',$_SERVER['HTTP_ACCEPT'])){

			header("Content-type:text/plain");	

		}else{

			header("Content-type:text/html");	

		}	

	}

	// start output

	function Start_Output($header=true){

	  if($this->is_ajax){

		ob_end_clean();

		if(!headers_sent()){

			$this->Send_Header();	

		}

		return true;

	  }

	}

	// end output

	function End_Output(){

	  if($this->is_ajax){

		ob_end_flush();

		exit();

	  }

	}

	// build output

	function Build_Output($options=false,$load=''){	

		// cgi bug

		// load for twice for cgi servers

		if(mga_is_cgi_server()){						

			mga_set_include_path();

		}		

		// ajax call

		if($this->is_ajax){

			$load=(!empty($load))? $load : $_GET['load'];

			if(isset($load) && !empty($load)){

				$options=$this->Filter_Options($options);

				// page

				$page = $load . $options['extension'];

				$this->Start_Output();			

				if(file_exists(MGA_PLUGIN_DIR_PATH . $options['container'] . DIRECTORY_SEPARATOR . $page)){					

					require_once(MGA_PLUGIN_DIR_PATH . $options['container'] . DIRECTORY_SEPARATOR . $page);

				}else{

					echo 'File ['.$options['container'] . DIRECTORY_SEPARATOR. $page.'] could not be loaded.';

				}

				$this->End_Output();

			}

		}

	}

	// options

	function Filter_Options($options){

		$d_options=array('container'=>implode(DIRECTORY_SEPARATOR, array('templates','admin')),'extension'=>'.tpl.php');

		if(is_array($options)){

			$d_options=array_merge($d_options,$options);

		}

		// send

		return $d_options;

	}

}

// end of file