<?php
// globals
define('MGA_PLUGIN_DIR_PATH'    , plugin_dir_path( __FILE__ ) );
define('MGA_PLUGIN_DIR_URL'     , plugin_dir_url( __FILE__ ) );	
define('MGA_PLUGIN_ASSETS_URL'  , MGA_PLUGIN_DIR_URL.'assets/' );	

global $ajax;

// admin menu

function mga_admin_menu() {        

    add_menu_page(__('Magic Affiliate','mga'), __('Magic Affiliate','mga'), 'administrator', 'mga/admin', 'mga_load_adminpage');    

}

// admin manage

function mga_load_adminpage(){

	

    global $wpdb,$ajax;    	
    // download with post

    if($_GET['load']=='payfile_download'){

        require_once(implode(DIRECTORY_SEPARATOR, array('templates','admin')) . DIRECTORY_SEPARATOR . 'payfile_download.tpl.php');    

        exit();

    }
	
	
    // ajax

    $ajax=new Mga_Ajax();   
	

    // build

    $ajax->Build_Output();

    // load interface

    require_once('admin/index.php');    

} // end function

// activate

function mga_activate(){

    global $wpdb;

    // after activation          

        // when not run

        if(!defined('mga_installed')){

            // define tables constants

            define('TBL_AFFILITES'      , $wpdb->prefix . "mga_affiliates");

            define('TBL_AFFILITE_TIERS' , $wpdb->prefix . "mga_affiliate_tiers");        

            define('TBL_BANNERS'        , $wpdb->prefix . "mga_banners");

            define('TBL_CLICKS'         , $wpdb->prefix . "mga_clicks");

            define('TBL_SALES'          , $wpdb->prefix . "mga_sales");

            define('TBL_COUNTRIES'      , $wpdb->prefix . "mga_countries");    

            // migration once / it will take care                 

            require_once('migration/mga_migrate.php');                                

            // set up daily cron event, once

            if ( !wp_next_scheduled('mga_daily_schedule') ){

                wp_schedule_event(time(), 'daily', 'mga_daily_schedule');    

            }

            // daily cron - used for refund process/slaes trackin

            add_action('mga_daily_schedule', 'mga_process_daily_schedule');     

            // define

            define('mga_installed',date('dmY'));

        }   

}

// activate

function mga_deactivate($remove_all=false){

    global $wpdb;

    

    // if remove

    if($remove_all){

        // uninstall options    

        $wpdb->query('DELETE FROM ' . $wpdb->options . ' WHERE `option_name` LIKE "mga_%" ');

        // tables

        $tables=array(TBL_AFFILITES, TBL_AFFILITE_TIERS, TBL_BANNERS, TBL_CLICKS, TBL_SALES, TBL_COUNTRIES);

        foreach($tables as $table){        

            $wpdb->query("DROP TABLE `{$table}`");        

        }

    }

    // clear daily event hook

    wp_clear_scheduled_hook('mga_daily_schedule');

}

// affiliate script
function mga_affiliate_script_load(){
	global $wp_query;
	
	// int css array
	$css_files = array();
	
	// from wp admin
	$css_files[] = admin_url('/css/global.css');
	
	// common
	$css_files[] = MGA_PLUGIN_ASSETS_URL . 'css/affiliate.css'; 
	$css_files[] = MGA_PLUGIN_ASSETS_URL . 'css/mga/jquery-ui.css';
	
	// init js array
	$js_files = array();
	// jquery from WP core, keep clash in mind, do not consider on admin
	if(get_option('mga_disable_core_jquery') != 'Y' || is_admin()){
		$js_files[] = includes_url('/js/jquery/jquery.js');
	}
	// form 
	$js_files[] = includes_url('/js/jquery/jquery.form.js');
	
	// custom
	$js_files[] = MGA_PLUGIN_ASSETS_URL . 'js/jquery/jquery.validate.pack.js';
	// $js_files[] = MGA_PLUGIN_ASSETS_URL . 'js/jquery/jquery.metadata.js';
	$js_files[] = MGA_PLUGIN_ASSETS_URL . 'js/jquery/jquery.scrollTo-min.js';	
	$js_files[] = MGA_PLUGIN_ASSETS_URL . 'js/helpers.js';
	$js_files[] = MGA_PLUGIN_ASSETS_URL . 'js/string.js';
	
	// ui on wp version			
	$jqueryui_version = mga_get_jqueryui_version();	
	// add to array
	$js_files[] = MGA_PLUGIN_ASSETS_URL . 'js/jquery/jquery.ui/jquery-ui-'.$jqueryui_version.'.min.js';
	
	// print css
	// css format
	$css_link_format = '<link rel="stylesheet" href="%s" type="text/css" media="all" />';
	// use wp css plugin	
	foreach($css_files as $css_file){
		echo sprintf($css_link_format, $css_file);
	}	
	
	// print js
	// js format
	$js_script_format = '<script type="text/javascript" src="%s"></script>';
	// use wp js plugin	
	foreach($js_files as $js_file){
		echo sprintf($js_script_format, $js_file);
	}
}


// admin scripts, css
function mga_admin_script_load() { 
	// jquery from WP core	
	wp_enqueue_script('jquery');	
	// form
	wp_enqueue_script('jquery-form');   

	// load respective JQueryUI
	$jqueryui_version = mga_get_jqueryui_version();
	// load ui
	wp_enqueue_script('mga-jquery-ui', MGA_PLUGIN_ASSETS_URL . 'js/jquery/jquery.ui/jquery-ui-'.$jqueryui_version.'.min.js');  

	// helpers scripts
	wp_enqueue_script('mga-jquery-validate' , MGA_PLUGIN_ASSETS_URL . 'js/jquery/jquery.validate.pack.js');
	wp_enqueue_script('mga-jquery-scrollto' , MGA_PLUGIN_ASSETS_URL . 'js/jquery/jquery.scrollTo-min.js');
	
	// custom scripts	
	wp_enqueue_script('mga-string'  , MGA_PLUGIN_ASSETS_URL . 'js/string.js');  
	wp_enqueue_script('mga-helpers' , MGA_PLUGIN_ASSETS_URL . 'js/helpers.js');      
	
		 
	      
	// only used for admin
    wp_enqueue_script('mga-jquery-ajaxupload' , MGA_PLUGIN_ASSETS_URL . 'js/jquery/jquery.ajaxfileupload.js'); 
    wp_enqueue_script('mga-jquery-corner'     , MGA_PLUGIN_ASSETS_URL . 'js/jquery/jquery.corner.js');        
    wp_enqueue_script('mga-nicedit'           , MGA_PLUGIN_ASSETS_URL . 'js/nicedit/nicedit.js'); 
	
	// ui css    
	wp_enqueue_style('mga-ui-css' , MGA_PLUGIN_ASSETS_URL . 'css/mga/jquery-ui.css' );
	
    // only admin styles    
    if (is_admin()) :
        // styles
        wp_enqueue_style('mga-adminstyles', MGA_PLUGIN_ASSETS_URL . 'css/admin.css' );       
	endif;

} 

// affiliate click tracking

function mga_affaccount_load(){
    global $wpdb,$wp_query,$ajax;       

	// test
	// mga_mail_notify_affiliate(1);
		
    // ajax
    $ajax=new Mga_Ajax();    

    // sub affiliate 
    if( isset( $wp_query->query_vars['paraffid'] )) {        
        setcookie('MGA_TRACK_PARAFFILIATE_ID',$wp_query->query_vars['paraffid'],strtotime("+1 DAY"),SITECOOKIEPATH);
    }

    // set click cookie

    if( isset( $wp_query->query_vars['affid'] ) || isset($_GET['affid'])) {            

        $affiliate_id  = isset( $wp_query->query_vars['affid'] ) ? intval($wp_query->query_vars['affid']) : intval($_GET['affid']);                

        $ip            = $_SERVER['REMOTE_ADDR'];     

        $referral_url  = $_SERVER['HTTP_REFERER'];
		
		// take user agent if referer is missing
		if(empty($referral_url)){
			$referral_url = substr($_SERVER['HTTP_USER_AGENT'], 0, 150);			
		}

        $hit_dt        = date('Y-m-d h:i:s');        

        if($affiliate_id>0 && !empty($referral_url)){                    

            $columns =array('affiliate_id' => $affiliate_id, 'ip' => $ip, 'referral_url' => $referral_url, 'hit_dt' => $hit_dt);            

            $wpdb->insert(TBL_CLICKS, $columns);

            $click_id=$wpdb->insert_id;

            if($click_id>0){

                $cookie_life=mga_get_setting('cookie_life','general',30);                

                setcookie('MGA_TRACK_SALE_CLICK_ID',$click_id,strtotime("+{$cookie_life} DAY"),SITECOOKIEPATH);                            

            }

        }            
    
        // reset for front 
        if(is_home() && get_option('show_on_front') == 'page' && (int)get_option('page_on_front')>0){            
            // reset
            wp_reset_query();
            // set query
            query_posts('page_id='.get_option('page_on_front'));
        }    
    }

    // load affcenter if set

    if( isset( $wp_query->query_vars[MGA_AFFCENTER_URLNAME] )) {     

		// wp head
		// head js scripts 
		// add_action('wp_head', 'mga_affiliate_script_load');
		add_action('affiliate_center_header', 'mga_affiliate_script_load');	
		// add_action('affiliate_center_footer', 'mga_affiliate_script_load_footer');		
        // start session 

        // if(!session_id()) session_start();    

        // if(!session_id())  // do not check session id causes trouble on godaddy issue:#31

        session_start();    

        // uri

        $uri=new Mga_URI($wp_query->query_vars[MGA_AFFCENTER_URLNAME]);    

        // loadable

        $load=$uri->Segment(0);                

        // build output

        $ajax->Build_Output(array('container'=>implode(DIRECTORY_SEPARATOR, array('templates','affiliate'))),$load);    

        // load interface only on post            

        require_once('affiliate/index.php');            

        // exit

        exit();    

    }

}

// sales tracking

function mga_sales_tracking($args){    

    global $wpdb;    

    $sessionid  = $_GET['sessionid'];    

    $click_id   = $_COOKIE['MGA_TRACK_SALE_CLICK_ID'];

    // when cookie

    if(intval($click_id)>0 && !empty($sessionid)){        

        // get purchase log

        $purchase = $wpdb->get_row("SELECT id,totalprice,transactid,processed FROM `".$wpdb->prefix."wpsc_purchase_logs` WHERE sessionid='{$sessionid}'",ARRAY_A);    

        // previous log

        $sale_id = $wpdb->get_var("SELECT id FROM `".TBL_SALES."` WHERE purchaseid='{$purchase['id']}'");            

        // first check transaction logged        

        if(intval($sale_id)==0){                

            // affiliate id

            $affiliate_id =$wpdb->get_var("SELECT affiliate_id FROM ".TBL_CLICKS." WHERE id='{$click_id}'");

            // cart data

            $cart=$wpdb->get_row("SELECT prodid FROM `".$wpdb->prefix."wpsc_cart_contents` WHERE purchaseid='{$purchase['id']}'",ARRAY_A);    

            // buyer email        

            $sql="SELECT A.value FROM `" . $wpdb->prefix . "wpsc_submited_form_data` A JOIN `" . $wpdb->prefix . "wpsc_checkout_forms` B 

                  ON(A.form_id=B.id) WHERE B.unique_name='billingemail' AND A.log_id='{$purchase['id']}'";     

            // get buyer email

            $buyer_email = $wpdb->get_var($sql);                

            // buyer billingfirstname        

            $sql="SELECT A.value FROM `" . $wpdb->prefix . "wpsc_submited_form_data` A JOIN `" . $wpdb->prefix . "wpsc_checkout_forms` B 

                  ON(A.form_id=B.id) WHERE B.unique_name='billingfirstname' AND A.log_id='{$purchase['id']}'";     

            // get buyer firstname

            $buyer_firstname = $wpdb->get_var($sql);    

            // buyer billinglastname        

            $sql="SELECT A.value FROM `" . $wpdb->prefix . "wpsc_submited_form_data` A JOIN `" . $wpdb->prefix . "wpsc_checkout_forms` B 

                  ON(A.form_id=B.id) WHERE B.unique_name='billinglastname' AND A.log_id='{$purchase['id']}'";     

            // get buyer lastname

            $buyer_lastname = $wpdb->get_var($sql);    

            $buyer_name     = $buyer_firstname.' '.$buyer_lastname;

            // set sale

            $sale_dt           = date('Y-m-d h:i:s');

            $commission_amount = mga_get_affiliate_commission_amount($affiliate_id,$purchase['totalprice']);

            $transaction_id    = (!empty($purchase['transactid']))?$purchase['transactid']:$sessionid; 

            $pay_status        = (intval($purchase['processed'])>1) ? 'processed':'pending';

            // set cols     NOTE: MUST NOT SAVE 'buyer_id' as it is tracked as recurring membership payments        

            $columns =array('affiliate_id' => $affiliate_id, 'click_id' => $click_id, 'purchaseid' => $purchase['id'] , 

                            'totalprice' => $purchase['totalprice'], 'commission_amount' => $commission_amount, 

                            'sale_dt' => $sale_dt, 'buyer_name' => $buyer_name, 'buyer_email' => $buyer_email, 

                            'item_type' => 'sales' , 'item_id' => $cart['prodid'], 'transaction_id' => $transaction_id, 

                            'pay_status' => $pay_status);

            // insert

            $success=$wpdb->insert(TBL_SALES, $columns);

            // sale id

            $sale_id=$wpdb->insert_id;

            // send mail to affiliate

            if($success==true && $pay_status=='processed'){

                // affiliate

                mga_mail_notify_affiliate($sale_id);

                // admin

                mga_mail_notify_admin($sale_id,'sale');

            }

            // tier commissions

            mga_create_tier_commissions($sale_id);                

            // remove cookie

            unset($_COOKIE['MGA_TRACK_SALE_CLICK_ID']);

            setcookie ('MGA_TRACK_SALE_CLICK_ID', '', time() - 3600, SITECOOKIEPATH);        

        }

    }else if(isset($args['purchase_id'])){    

        // process status    

        $sale =$wpdb->get_row("SELECT * FROM ".TBL_SALES." WHERE purchaseid='{$args['purchase_id']}'");

        // change 

        mga_check_payment_status($sale);    

    }else{

        // set all processed    

        $sales = $wpdb->get_results("SELECT id,pay_status,purchaseid FROM ".TBL_SALES." WHERE pay_status='pending'");        

        if($sales){

            foreach ($sales as $sale) {                

                mga_check_payment_status($sale);

            }

        }    

    }    

}



// membership sales tracking : step 1, called on register submit and create sale entry with 'pending' status

function mga_membership_register($user_id){    

    // db

    global $wpdb;        

    // buyer

    $buyer_id = $user_id;        

    // is any module active?

    $membershipmods=mga_get_setting('membership','recurringmodules');

    // when one module active

    if(count($membershipmods)>0){

        // if it is enabled ?        

        $recurring_enabled=mga_get_setting('recurring_commission_enabled','general','N');

        // enabled

        if($recurring_enabled=='Y'){            

            // first sale cookie avaialble

            $click_id = $_COOKIE['MGA_TRACK_SALE_CLICK_ID'];

            // when set

            if($click_id){

                // affiliate from clicks

                $affiliate_id =$wpdb->get_var("SELECT affiliate_id FROM ".TBL_CLICKS." WHERE id='{$click_id}'");        

                // for magic members

                $totalprice = 0;

                if(in_array('magicmembers',$membershipmods)){

                    // get user

                    $user              = get_userdata((int) $buyer_id);    

                    // transaction from mm                    

                    // get pack form post

                    list($amount,$duration,$duration_type,$account_type)=explode('_',$_POST['mgm_subscription']);                    

                    // set values

                    $totalprice        = $amount;

                    $buyer_name        = $user->display_name;

                    $buyer_email       = $user->user_email;

                    $sale_dt           = date('Y-m-d h:i:s');

                    // get general or individual level commission settings

                    $commission_amount = mga_get_affiliate_recurring_commission_amount($affiliate_id,$amount);

                    $purchaseid        = '';

                    $transaction_id    = ''; 

                    $item_id           = '';

                    $pay_status        = 'pending';                    

                }

                // with amount

                if($totalprice){

                    // set columns NOTE: MUST SAVE 'buyer_id' as it is tracked as recrrung membership payments    

                    $columns =array('affiliate_id' => $affiliate_id, 'click_id' => $click_id, 'purchaseid' => $purchaseid,

                                    'totalprice' => $totalprice, 'commission_amount' => $commission_amount,

                                    'sale_dt' => $sale_dt, 'buyer_id' => $buyer_id, 'buyer_name' => $buyer_name,

                                    'buyer_email' => $buyer_email, 'item_type' => 'sales' , 'item_id' => $item_id,

                                    'transaction_id' => $transaction_id, 'pay_status' => $pay_status);

                    // insert

                    $success=$wpdb->insert(TBL_SALES, $columns);

                    // sale id

                    $sale_id=$wpdb->insert_id;

                    // tier commissions

                    mga_create_tier_commissions($sale_id);        

                    // remove cookie

                    unset($_COOKIE['MGA_TRACK_SALE_CLICK_ID']);

                    setcookie ('MGA_TRACK_SALE_CLICK_ID', '', time() - 3600, SITECOOKIEPATH);    

                }// end    

            }

        }

    }        

}    

// membership sales tracking : called when payment is made and status updated 

function mga_membership_sales_tracking($args){    

    global $wpdb;    

    // buyer

    $buyer_id = $args['user_id'];

    // is any module active?

    $membershipmods = mga_get_setting('membership','recurringmodules');

    // $message="Start: ".$buyer_id;

    if(is_array($membershipmods) && count($membershipmods)>0){

        // after sales track for table // AND DATE_FORMAT(`sale_dt`,'%Y-%m-%d') <> CURRENT_DATE

        $sql = "SELECT * FROM ".TBL_SALES." WHERE buyer_id='{$buyer_id}' ORDER BY `sale_dt` DESC LIMIT 0,1";

        // sale data

        $sale_data = $wpdb->get_row($sql,ARRAY_A);        

        // first sale, change status to processed

        if(isset($sale_data['affiliate_id']) && $sale_data['pay_status']=='pending'){

            // update columns

            $success=$wpdb->update(TBL_SALES, array('pay_status' => 'processed'), array('id'=>$sale_data['id']));

            // mail to affiliate

            mga_mail_notify_affiliate($sale_data['id']);

            // mail to admin

            mga_mail_notify_admin($sale_data['id'],'sale');            

        // second sale (next time auto pay), insert new row

        }else if(isset($sale_data['affiliate_id']) && $sale_data['pay_status']=='processed'){                    

            // extract

            extract($sale_data);

            // change sale date

            $sale_dt = date('Y-m-d h:i:s');

            // set columns

            $columns = array('affiliate_id' => $affiliate_id, 'click_id' => $click_id, 'purchaseid' => $purchaseid , 

                              'totalprice' => $totalprice, 'commission_amount' => $commission_amount, 

                             'sale_dt' => $sale_dt, 'buyer_id' => $buyer_id, 'buyer_name' => $buyer_name, 

                             'buyer_email' => $buyer_email, 'item_type' => 'sales' , 'item_id' => $item_id, 

                             'transaction_id' => $transaction_id, 'pay_status' => $pay_status);

            // insert

            $success=$wpdb->insert(TBL_SALES, $columns);

            // sale id

            $sale_id=$wpdb->insert_id;            

            // mail to affiliate

            mga_mail_notify_affiliate($sale_id);

            // mail to admin

            mga_mail_notify_admin($sale_id,'sale');

        }    

    }    

}

// shopperpress sales tracking : step 2, called when payment is made and status updated to 'processed'
function mga_shopperpress_sales_tracking($order_id, $status){
	
	// mga_log('mga_shopperpress_sales_tracking: '.$order_id .', '. $status); 
}


// add rules 

function mga_affaccount_rewrite_rules( $wp_rewrite ){

    // named 

    if(get_option('permalink_structure')!=''){    

        $new_rules[MGA_AFFCENTER_URLNAME.'$']    = 'index.php?'.MGA_AFFCENTER_URLNAME.'=login';    

        $new_rules[MGA_AFFCENTER_URLNAME.'(.*)'] = 'index.php?'.MGA_AFFCENTER_URLNAME.'=' .$wp_rewrite->preg_index(1) ;

        $wp_rewrite->rules = $new_rules + $wp_rewrite->rules;        

    }

}

// add query vars

function mga_affaccount_rewrite_queryvars( $qvars ){  

  array_push($qvars, MGA_AFFCENTER_URLNAME);

  array_push($qvars, 'affid');

  array_push($qvars, 'paraffid');  

  array_push($qvars, 'pageoffset');    

  return $qvars;

}

// flush rewrite rules

function mga_affaccount_flush_rewrite_rules(){

   global $wp_rewrite;

   $wp_rewrite->flush_rules();

}

// process daily cron 

function mga_process_daily_schedule(){

    global $wpdb;    

    // check all sale status and set processed/refund 

    $sales = $wpdb->get_results("SELECT id,pay_status,purchaseid FROM ".TBL_SALES." WHERE pay_dt IS NULL");        

    if($sales){

        foreach ($sales as $sale) {                

            mga_check_payment_status($sale);

        }

    }

        

    // check membership sales dates and update commision if any data mismatch

    $sales = $wpdb->get_results("SELECT DISTINCT `buyer_id` FROM ".TBL_SALES." WHERE `pay_dt` IS NULL AND `buyer_id` IS NOT NULL");    

    // soem sales done

    if($sales){

        foreach ($sales as $sale) {        

            // last sale                

            $sale_data = $wpdb->get_var("SELECT * FROM ".TBL_SALES." WHERE buyer_id='{$sale->buyer_id}' ORDER BY `sale_dt` DESC LIMIT 0,1");

            // get last payment from usermeta

            $user_data = get_usermeta($sale->buyer_id, 'mgm_user');

            // when last pay date in user data is later than sale date in sale table

            // treat as membership extend

            if( strtotime($user_data->last_pay_date) > strtotime($sale_data->sale_dt) ){

                // extract

                extract($sale_data);

                // change sale date

                $sale_dt = date('Y-m-d h:i:s');

                // set columns NOTE: MUST SAVE 'buyer_id' as it is tracked as recrrung membership payments    

                $columns =array('affiliate_id' => $affiliate_id, 'click_id' => $click_id, 'purchaseid' => $purchaseid , 

                                'totalprice' => $totalprice, 'commission_amount' => $commission_amount, 

                                'sale_dt' => $sale_dt, 'buyer_id' => $buyer_id, 'buyer_name' => $buyer_name, 

                                'buyer_email' => $buyer_email, 'item_type' => 'sales' , 'item_id' => $item_id, 

                                'transaction_id' => $transaction_id, 'pay_status' => $pay_status);

                // insert

                $success =$wpdb->insert(TBL_SALES, $columns);                
            }            
        }
    }
}    

// setup

function mga_plugins_loaded(){     

    // affcenter url

    define('MGA_AFFCENTER_URLNAME',mga_get_setting('affiliate_login_url','general','affaccount'));        

    // scripts, css for admin only
	if (is_admin() ){   
    	add_action('init', 'mga_admin_script_load');   
	}

    // lang    

    load_plugin_textdomain( 'mga', false, dirname( plugin_basename( __FILE__ ) ) . '/lang' );    

    // after activation, enable affcenter

        // generate rewrite

        add_action('generate_rewrite_rules', 'mga_affaccount_rewrite_rules');

        // add query vars

        add_filter('query_vars', 'mga_affaccount_rewrite_queryvars' );

        // flush rewrite

        add_action('init', 'mga_affaccount_flush_rewrite_rules');

        // parse query hook for param loads

        add_action('parse_query', 'mga_affaccount_load');    

        // register form hook for tracking membership sales

        add_action('register_form', 'mga_affaccount_load');    

        // register hook for tracking membership sales

        add_action('user_register', 'mga_membership_register');                


    // admin actions    

    if (is_admin() ){       

      // add menu    

      add_action('admin_menu', 'mga_admin_menu' );    

    }       

    // wpsc hook, called when transaction status change

    add_action('wpsc_transaction_result_cart_item','mga_sales_tracking');    

    // mgm hook, called when any membership payment is success

    add_action('mgm_membership_transaction_success', 'mga_membership_sales_tracking');
	
	// shopperpress hook, called when any order status updated
	// add_action('shopperpress_order_status_change','mga_shopperpress_sales_tracking');    

    // activation trigger      

    $plugin_file = trailingslashit(str_replace('protected/mga_main.php','magicaffiliate.php',str_replace('\\', '/', __FILE__)));      

    // auto call

    register_activation_hook($plugin_file, 'mga_activate');

    // once enabled this will erase all data for plugin, 

    // 27/02/2010 keep it enabled as we need to remove schedule hook

    // no data is removed unless called with true argument

    // done at settings remove option

    register_deactivation_hook($plugin_file, 'mga_deactivate');

    // force call once

    mga_activate();            

}
// setup  
add_action('plugins_loaded', 'mga_plugins_loaded'); 
// end of file 