<?php

	// table schema
	// add affiliate table
	$sql = "CREATE TABLE IF NOT EXISTS `" . TBL_AFFILITES . "` (
			`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`title` enum('Mr','Mrs','Miss','Ms','Dr') DEFAULT 'Mr', 
			`firstname` varchar(50) NOT NULL,
			`lastname` varchar(50) NOT NULL,
			`company` varchar(100) NULL,
			`website` varchar(100) NULL,
			`email` varchar(150) NOT NULL,
			`password` varchar(50) NOT NULL,
			`paypal_email` varchar(150) NULL,	
			`street` varchar(50) NULL,
			`city` varchar(50) NULL,
			`state` varchar(50) NULL,
			`zip` varchar(10) NULL,				
			`country_code` char(2) NULL,
			`phone` varchar(15) NULL,	
			`fax` varchar(15) NULL,	
			`create_dt` datetime NOT NULL,	
			`config` longtext NULL,					
			PRIMARY KEY (`id`),
			UNIQUE (`email`)
		) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Affiliate records'";
	$wpdb->query($sql);
	
	// add affiliate tiers table
	$sql = "CREATE TABLE IF NOT EXISTS `".TBL_AFFILITE_TIERS."` (
			   `affiliate_id` int(11) unsigned NOT NULL,
			   `parent_affiliate_id` int(11) unsigned NOT NULL,
				UNIQUE KEY `affiliate_id` (`affiliate_id`,`parent_affiliate_id`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Affiliate tiers';
			";
	$wpdb->query($sql);
	
	// add banner table
	$sql = "CREATE TABLE IF NOT EXISTS `" . TBL_BANNERS . "` (
			`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`name` varchar(150) NOT NULL,
			`description` varchar(255) NOT NULL,
			`link_text` varchar(150) NOT NULL,
			`target_url` varchar(255) NOT NULL,
			`image_url` varchar(255) NOT NULL,		
			`image_property` VARCHAR( 255 ) NULL, 
			`flash_embed` TEXT NOT NULL,
			`banner_type` ENUM( 'image', 'link', 'flash' ) NOT NULL,
			`is_active` ENUM( 'Yes', 'No' ) NOT NULL,		
			`create_dt` datetime NOT NULL,
			PRIMARY KEY (`id`),
			UNIQUE (`name`)
		) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Banner records'";
	$wpdb->query($sql);	
	
	// add clicks table
	$sql = "CREATE TABLE IF NOT EXISTS `" . TBL_CLICKS . "` (
			`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`affiliate_id` int(11) unsigned NOT NULL,
			`ip` varchar(50) NOT NULL,	
			`referral_url` varchar(150) NULL,					
			`hit_dt` datetime NOT NULL,
			PRIMARY KEY (`id`),
			UNIQUE KEY `affiliate_id` (`affiliate_id`,`ip`,`referral_url`)
		) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Click records'";
	$wpdb->query($sql);	
	
	// sales table	
	$sql="CREATE TABLE IF NOT EXISTS `" . TBL_SALES . "` (
			`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`affiliate_id` INT(11) UNSIGNED NOT NULL ,
			`click_id` INT( 11 ) UNSIGNED NULL,
			`purchaseid` BIGINT( 20 ) UNSIGNED NULL,
			`totalprice` DECIMAL( 11, 2 ) UNSIGNED NOT NULL, 
			`commission_amount` DECIMAL( 5, 2 ) UNSIGNED NOT NULL ,
			`sale_dt` DATETIME NOT NULL ,
			`buyer_id` INT( 11 ) UNSIGNED NULL,
			`buyer_name` VARCHAR( 150 ) NULL,
			`buyer_email` VARCHAR( 100 ) NULL ,
			`item_type` enum('sales','signup') NOT NULL DEFAULT 'sales',
			`item_id` INT(11) UNSIGNED NULL ,
			`transaction_id` VARCHAR( 50 ) NULL,
			`pay_status` ENUM( 'pending', 'processed', 'refund') NOT NULL DEFAULT 'pending',
			`pay_dt` DATETIME NULL DEFAULT NULL
			) ENGINE = MYISAM DEFAULT CHARSET=latin1 COMMENT = 'Sales records'";
	$wpdb->query($sql);
	
	// add countries
	$sql = "CREATE TABLE IF NOT EXISTS `" . TBL_COUNTRIES . "` (
			`id` INTEGER UNSIGNED AUTO_INCREMENT,
			`name` VARCHAR(255) NOT NULL,
			`code` VARCHAR(10) NOT NULL,
			PRIMARY KEY (`id`)
		) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Countries'";
	$wpdb->query($sql);	
// end of file